#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
 * ------------------------------------------------------------------------
 * bmSearch
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.bm-stats.org <http://www.bm-stats.org>
 * -----
"""

# Native Python Lib/Class 
import logging
from logging.handlers import RotatingFileHandler

# bmSearch Class
import config


class logger():

        def __init__(self):
                """
                __init__:
                        init the logger in DEBUG mode.
                
                """
		logFile       = config.logFile
		logFileSize   = config.logFileSize
		logFileBackup = config.logFileBackup

                self.logger = logging.getLogger()
                self.logger.setLevel(logging.DEBUG)
                self.formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
                self.file_handler = RotatingFileHandler(logFile, 'a', logFileSize, logFileBackup)
                self.file_handler.setLevel(logging.DEBUG)
                self.file_handler.setFormatter(self.formatter)
                self.logger.addHandler(self.file_handler)
                
                
        def catch(self, string):
                """
                catch:
                        feed the logger with string
                """
        	logging.exception(string)
        	
        	
 
        def add(self, level, string):                
                """
                add :
                        add lines to appender(file log).
                        Args are :
                                - (str) level 
                                - (str) string, a more explicative information.
                                
                                
                        Log Levels:         
                                CRITICAL         50
                                ERROR            40
                                WARNING          30
                                INFO             20
                                DEBUG            10
                """
                if level.lower() == "debug":
                        self.logger.debug(string)
                        
                if level.lower() == "info":
                        self.logger.info(string)        
                        
                if level.lower() == "warning":
                        self.logger.warning(string)
                        
                if level.lower() == "error":
                        self.logger.error(string)
                        
                if level.lower() == "critical":
                        self.logger.critical(string)


